package net.junkpixel;

import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.entity.Item;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.PlayerDeathEvent;
import org.bukkit.inventory.ItemStack;
import org.bukkit.plugin.java.JavaPlugin;
import org.bukkit.scheduler.BukkitRunnable;

import java.util.List;
import java.util.Random;

public class BrutalDeath extends JavaPlugin implements Listener {

    private FileConfiguration config;

    @Override
    public void onEnable() {
        saveDefaultConfig();
        config = getConfig();
        Bukkit.getPluginManager().registerEvents(this, this);
        getLogger().info("BrutalDeath enabled.");
    }

    @Override
    public void onDisable() {
        getLogger().info("BrutalDeath disabled.");
    }

    @EventHandler
    public void onPlayerDeath(PlayerDeathEvent event) {
        Player player = event.getEntity();
        List<String> itemNames = config.getStringList("spew-items");
        int durationTicks = config.getInt("spew-duration", 40); // in ticks
        int multiplier = config.getInt("spew-multiplier", 1); // default to 1 if missing

        Random random = new Random();

        for (String itemName : itemNames) {
            Material material = Material.matchMaterial(itemName);
            if (material == null) continue;

            for (int i = 0; i < multiplier; i++) {
                ItemStack itemStack = new ItemStack(material);
                Item dropped = player.getWorld().dropItemNaturally(
                        player.getLocation().add(
                                (random.nextDouble() - 0.5) * 2,
                                1,
                                (random.nextDouble() - 0.5) * 2
                        ),
                        itemStack
                );

                dropped.setPickupDelay(Integer.MAX_VALUE);

                new BukkitRunnable() {
                    @Override
                    public void run() {
                        dropped.remove();
                    }
                }.runTaskLater(this, durationTicks);
            }
        }
    }
}
